/***************************************************************************
 *                                                                         *
 *    NoMoRe++                                                             *
 *                                                                         *
 *    Copyright (C) 2003-2005 NoMoRe Developing Group                      *
 *                                                                         *
 *    For more information, see http://www.cs.uni-potsdam.de/nomore/       *
 *    or email to nomore-dg@cs.uni-potsdam.de                              *
 *                                                                         *
 *                                                                         *
 *    This program is free software; you can redistribute it and/or        *
 *    modify it under the terms of the GNU General Public License          *
 *    as published by the Free Software Foundation; either version 2       *
 *    of the License, or (at your option) any later version.               *
 *                                                                         *
 *    This program is distributed in the hope that it will be useful,      *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *    GNU General Public License for more details.                         *
 *                                                                         *
 *    You should have received a copy of the GNU General Public License    *
 *                                                                         *
 ***************************************************************************/

#if defined (_MSC_VER) && _MSC_VER <= 1300
#pragma warning (disable : 4786)
#endif

#include <choice_operator.h>
#include <graph.h>
#include <heuristic.h>
#include <node.h>

namespace NS_NOMORE {

ChoiceOperator::ChoiceOperator(Graph& grp, Heuristic* h)
  : Operator(grp)
  , graph_(&grp)
  , heuristic_(h) {
  heuristic_->setGraph(grp);
}

ChoiceOperator::~ChoiceOperator() {
  delete heuristic_;
}

ColorOpResult ChoiceOperator::operator()() {
  if (Choice c = selectChoice()) {
    return graph_->colorChoicePoint(*c.node(), c.preferredColor(), c.alternativeColor())
      ? ColorOperation::succeeded 
      : ColorOperation::failed;
  }
  return ColorOperation::unchanged;
}

}
